% Construit la trajectoire d'aprs les mesures DVL et IMU

close all
clear all
clc

[path2] = uigetdir;

load([path2,'/DATA_MISSION_VALID']);
load([path2,'/IMPACT_SONAR_TRITECH_ONL']);

t_end=min([IMU_VALID.GLOB_TIME(end),DVL_VALID.GLOB_TIME(end)]);

count_echosound=1;
count_DVL=1;
count_glob=1;
count_IMPACT = 2;
count_IMPACT_VALID = 1;

%Rotation DVL -> Body frame
Q_DVL_B = [cos(pi/2) 0 0 sin(pi/2)];

%Rotation repere aerien -> marin
Q_TER_MARIN = [cos(pi/2) sin(pi/2) 0 0];

%Rotation IMU -> Body frame (rotation suivant z de pi/2, sens horaire
Q_IMU_B = [cos(pi/4) 0 0 sin(pi/4)];

%
%CURRENT_QUAT = ECHOSOUND_VALID.QUAT(count_echosound,:);
CURRENT_QUAT = IMU_VALID.QUAT(count_echosound,:);

Q_TEMP = quatmultiply(Q_DVL_B,quatmultiply([0 DVL_VALID.U(count_DVL) DVL_VALID.V(count_DVL) DVL_VALID.W(count_DVL)],quatconj(Q_DVL_B)));
CURRENT_VEL = Q_TEMP(2:4);
CURRENT_DEPTH = -DVL_VALID.PRESSURE(count_DVL);
X(:,count_glob)=[0 0 0]';
new_data=0;
new_data_impact=0;
dt=1e-3;
for tps = 0 : t_end
    %     if (count_echosound<=length(ECHOSOUND_VALID.GLOB_TIME))
    %         if ECHOSOUND_VALID.GLOB_TIME(count_echosound)<tps
    %             CURRENT_QUAT = ECHOSOUND_VALID.QUAT(count_echosound,:);
    %             count_echosound=count_echosound+1;
    %             new_data=1;
    %         end
    %     end

    if (count_echosound<=length(IMU_VALID.GLOB_TIME))
        if IMU_VALID.GLOB_TIME(count_echosound)<tps
            CURRENT_QUAT = IMU_VALID.QUAT(count_echosound,:);
            CURRENT_QUAT = quatmultiply(Q_TER_MARIN,CURRENT_QUAT);
            CURRENT_QUAT = quatmultiply(CURRENT_QUAT,Q_IMU_B);
            CURRENT_TIME_IMU = IMU_VALID.GLOB_TIME(count_echosound);
            count_echosound=count_echosound+1;
            new_data=1;
        end
    end

    if (count_DVL<=length(DVL_VALID.GLOB_TIME))
        if DVL_VALID.GLOB_TIME(count_DVL)<tps
            Q_TEMP = quatmultiply(Q_DVL_B,quatmultiply([0 DVL_VALID.U(count_DVL) DVL_VALID.V(count_DVL) DVL_VALID.W(count_DVL)],quatconj(Q_DVL_B)));
            CURRENT_VEL = Q_TEMP(2:4);
            CURRENT_DEPTH = -DVL_VALID.PRESSURE(count_DVL);
            CURRENT_TIME_DVL = DVL_VALID.GLOB_TIME(count_DVL);
            count_DVL=count_DVL+1;
            %new_data=1;
        end
    end



    if new_data==1
        count_glob=count_glob+1;
        Q_temp = quatmultiply(CURRENT_QUAT,quatmultiply([0 CURRENT_VEL],quatconj(CURRENT_QUAT)));
        dot_X = Q_temp(2:4)';
        X_time(count_glob)=tps;
        dt=(X_time(count_glob)-X_time(count_glob-1))*1e-3;
        X(:,count_glob) = X(:,count_glob-1) + dot_X*dt;
        X(3,count_glob) = CURRENT_DEPTH;
        X_QUAT(count_glob,:) = CURRENT_QUAT;
        VELOCITY(:,count_glob) = CURRENT_VEL';
        new_data=0;
    end

    if (count_IMPACT<=length(IMPACT_ONL.GLOB_TIME))
        if IMPACT_ONL.GLOB_TIME(count_IMPACT)<tps
            CURRENT_DIST = IMPACT_ONL.DIST (count_IMPACT);
            CURRENT_ANGLE = IMPACT_ONL.ANGLE (count_IMPACT);
            CURRENT_TIME_IMPACT = IMPACT_ONL.GLOB_TIME(count_IMPACT);
            count_IMPACT=count_IMPACT+1;
            new_data_impact=1;
        end
    end

    if new_data_impact==1
        CURRENT_IMPACT_QUAT_B = [cos((pi/180)*CURRENT_ANGLE/2),[-1 0 0]*sin((pi/180)*CURRENT_ANGLE/2)];
        Rot_z_pi = [cos(pi/2),[0 0 1]*sin(pi/2)];
        CURRENT_IMPACT_QUAT_B = quatmultiply(CURRENT_IMPACT_QUAT_B,Rot_z_pi);
        Rot_y_pi = [cos(pi/2),[0 1 0]*sin(pi/2)];
        CURRENT_IMPACT_QUAT_B = quatmultiply(CURRENT_IMPACT_QUAT_B,Rot_y_pi);

        CURRENT_IMPACT_QUAT_0 = quatmultiply(CURRENT_QUAT,CURRENT_IMPACT_QUAT_B);
        %Q_temp = quatmultiply(CURRENT_IMPACT_QUAT_0,quatmultiply([0 IMPACT.DIST(count_Impact) 0 0],quatconj(CURRENT_IMPACT_QUAT_0)));
        Q_temp = quatmultiply(CURRENT_IMPACT_QUAT_0,quatmultiply([0 0 0 CURRENT_DIST],quatconj(CURRENT_IMPACT_QUAT_0)));
        %IMPACT_S_TEMP = X + Q_temp(2:4)';
        %% RETRAIT DES IMPACTS ABBERANTS
        IMPACT_TEMP = X(:,end) + Q_temp(2:4)';
        if IMPACT_TEMP(3)<0
            [CURRENT_TIME_IMU CURRENT_TIME_DVL CURRENT_TIME_IMPACT]
            IMPACT_S_ONL(:,count_IMPACT_VALID) = X(:,end) + Q_temp(2:4)';

            disp('INTEGRER LE DELTA_X !!!')

            %ROB_POS(:,count_Stock)= CURRENT_X;
            %VEL_ROB(:,count_Stock)=CURRENT_VEL;
            count_IMPACT_VALID = count_IMPACT_VALID + 1;
            count_IMPACT_VALID
        end
        new_data_impact=0;
    end
end

%Visualisation de la trajectoire
% NavScoot_Graph = quiver3(0,0,0,5,0,0,'linewidth',6);
% hold on
% count_graph=1;
% for i = 1 :length(X)
%     count_graph=count_graph+1;
%     if count_graph>10
%         Dir_NS =10*quatmultiply(X_QUAT(i,:),quatmultiply([0 1 0 0],quatconj(X_QUAT(i,:))));
%         set(NavScoot_Graph,'xdata',X(1,i),'ydata',X(2,i),'zdata',X(3,i),'udata',Dir_NS(2),'vdata',Dir_NS(3),'wdata',Dir_NS(4));
%         plot3(X(1,i),X(2,i),X(3,i),'*r')
%         axis('equal')
%         drawnow
%         count_graph=1;
%     end
%
% end

%Visualisation de la trajectoire
% figure()
% plot3(X(1,:),X(2,:),X(3,:),'*r')
% axis equal
%
% figure()
% title('reperage des points d interet');
% subplot(4,1,1);ylabel('U')
% plot(X_time,VELOCITY(1,:))
% subplot(4,1,2);ylabel('X')
% plot(X_time,X(1,:))
% subplot(4,1,3);ylabel('Y')
% plot(X_time,X(2,:))
% subplot(4,1,4);ylabel('Z')
% plot(X_time,X(3,:))



save ([path2,'/DATA_TRAJECTOIRE_IMU'],'X','X_QUAT','X_time','VELOCITY');
save ([path2,'/IMPACT_ENV'],'IMPACT_S_ONL','X_QUAT','X_time','VELOCITY');

%load ([path2,'/INTERREST_POINTS']);
DECOUPAGE_TRAJECTOIRE(X,X_QUAT,X_time,VELOCITY,path2)
