function DECOUPAGE_TRAJECTOIRE(X,X_QUAT,X_time,VELOCITY,path2)


global Ref_Debut_Traj Ref_Fin_Traj Indice_Pt_Sel Name_Traj

% Create a figure and axes

f = figure('Visible','off');
set(f,'position',[19   133   653   822])

ax_TRAJ = axes('position',[0.1,0.6,0.85,0.45]);
hold on;grid on
Traj_Grpah = plot3(X(1,:),X(2,:),X(3,:),'*r');
axis equal

ax_VEL_U = axes('position',[0.1,0.38,0.85,0.1]);
plot(X_time,VELOCITY(1,:),'r');ylabel('U(m/s)')
hold on;grid on

ax_POS_X = axes('position',[0.1,0.28,0.85,0.1]);
plot(X_time,X(1,:),'r');ylabel('X(m)')
hold on;grid on

ax_POS_Y = axes('position',[0.1,0.18,0.85,0.1]);
plot(X_time,X(2,:),'r');ylabel('Y(m)')
hold on;grid on

ax_POS_Z = axes('position',[0.1,0.08,0.85,0.1]);
plot(X_time,X(3,:),'r');ylabel('Z(m)')
hold on;grid on

%     % Create pop-up menu
%     popup = uicontrol('Style', 'popup',...
%            'String', {'parula','jet','hsv','hot','cool','gray'},...
%            'Position', [20 340 100 50],...
%            'Callback', @setmap);

% Create push button
btn_Debut = uicontrol('Style', 'pushbutton', 'String', 'DEBUT TRAJ',...
    'Position', [50 430 100 20],...
    'Callback', @Store_Debut,'Enable','on');

btn_Fin = uicontrol('Style', 'pushbutton', 'String', 'Fin TRAJ',...
    'Position', [150 430 100 20],...
    'Callback', @Store_Fin,'Enable','off');

btn_Save = uicontrol('Style', 'pushbutton', 'String', 'Save TRAJ',...
    'Position', [250 430 100 20],...
    'Callback', @Save_Traj,'Enable','off');

btn_Reset = uicontrol('Style', 'pushbutton', 'String', 'Reset',...
    'Position', [350 430 100 20],...
    'Callback', @Reset_Traj,'Enable','off');

% Create slider
sld = uicontrol('Style', 'slider',...
    'Min',min(X_time),'Max',max(X_time),'Value',min(X_time),...
    'Position', [10 10 600 20],...
    'Callback', @Point_Choice);


% Add a text uicontrol to label the slider.
% txt = uicontrol('Style','text',...
%     'Position',[10 730 200 20],...
%     'String','Reperage des points d interet');

% Make figure visble after adding all components
f.Visible = 'on';

Indice_Pt_Sel = find(X_time>get(sld,'value'),1,'first');
Int_point_X = X(1,Indice_Pt_Sel);
Int_point_Y = X(2,Indice_Pt_Sel);
Int_point_Z = X(3,Indice_Pt_Sel);
Point_int_TRAJ = plot3(Int_point_X,Int_point_Y,Int_point_Z,'*b','visible','on','parent',ax_TRAJ,'marker','.','markersize',40);
Point_int_U = plot(X_time(Indice_Pt_Sel),VELOCITY(1,Indice_Pt_Sel),'*b','visible','on','parent',ax_VEL_U,'marker','.','markersize',25);
Point_int_X = plot(X_time(Indice_Pt_Sel),X(1,Indice_Pt_Sel),'*b','visible','on','parent',ax_POS_X,'marker','.','markersize',25);
Point_int_Y = plot(X_time(Indice_Pt_Sel),X(2,Indice_Pt_Sel),'*b','visible','on','parent',ax_POS_Y,'marker','.','markersize',25);
Point_int_Z = plot(X_time(Indice_Pt_Sel),X(3,Indice_Pt_Sel),'*b','visible','on','parent',ax_POS_Z,'marker','.','markersize',25);

btn_MOINS_100 = uicontrol('Style', 'pushbutton', 'String', '-100',...
    'Position', [50 30 100 20],...
    'Callback', @fct_Moins_10,'Enable','on');

btn_MOINS_10 = uicontrol('Style', 'pushbutton', 'String', '-10',...
    'Position', [150 30 100 20],...
    'Callback', @fct_Moins_10,'Enable','on');

btn_MOINS_1 = uicontrol('Style', 'pushbutton', 'String', '-1',...
    'Position', [250 30 100 20],...
    'Callback', @fct_Moins_1,'Enable','on');

btn_PLUS_1 = uicontrol('Style', 'pushbutton', 'String', '+1',...
    'Position', [350 30 100 20],...
    'Callback', @fct_Plus_1,'Enable','on');

btn_PLUS_10 = uicontrol('Style', 'pushbutton', 'String', '+10',...
    'Position', [450 30 100 20],...
    'Callback', @fct_Plus_10,'Enable','on');

btn_PLUS_100 = uicontrol('Style', 'pushbutton', 'String', '+100',...
    'Position', [550 30 100 20],...
    'Callback', @fct_Plus_100,'Enable','on');

% This code uses dot notation to set properties.
% Dot notation runs in R2014b and later.
% For R2014a and earlier: set(f,'Visible','on');

%     function setmap(source,callbackdata)
%         val = source.Value;
%         maps = source.String;
%         % For R2014a and earlier:
%         % val = get(source,'Value');
%         % maps = get(source,'String');
%
%         newmap = maps{val};
%         colormap(newmap);
%     end

    function fct_Moins_100(source,callbackdata)
        if Indice_Pt_Sel>100,
            Indice_Pt_Sel=Indice_Pt_Sel-100;
        end
        Update_Points_On_Graph(Indice_Pt_Sel);
    end

    function fct_Moins_10(source,callbackdata)
        if Indice_Pt_Sel>10,
            Indice_Pt_Sel=Indice_Pt_Sel-10;
        end
        Update_Points_On_Graph(Indice_Pt_Sel);
    end

    function fct_Moins_1(source,callbackdata)
        if Indice_Pt_Sel>1,
            Indice_Pt_Sel=Indice_Pt_Sel-1;
        end
        Update_Points_On_Graph(Indice_Pt_Sel);
    end



    function fct_Plus_1(source,callbackdata)
        if Indice_Pt_Sel<length(X)-1,
            Indice_Pt_Sel=Indice_Pt_Sel+1;
        end
        Update_Points_On_Graph(Indice_Pt_Sel);
    end

    function fct_Plus_10(source,callbackdata)
        if Indice_Pt_Sel<length(X)-10,
            Indice_Pt_Sel=Indice_Pt_Sel+10;
        end
        Update_Points_On_Graph(Indice_Pt_Sel);
    end

    function fct_Plus_100(source,callbackdata)
        if Indice_Pt_Sel<length(X)-100,
            Indice_Pt_Sel=Indice_Pt_Sel+100;
        end
        Update_Points_On_Graph(Indice_Pt_Sel);
    end

    function Store_Debut(source,callbackdata)
        Ref_Debut_Traj = Indice_Pt_Sel;
        set(btn_Fin,'enable','on');
        set(btn_Debut,'enable','off');        
    end

    function Store_Fin(source,callbackdata)
        Ref_Fin_Traj = Indice_Pt_Sel;
        set(btn_Save,'enable','on');
        set(btn_Reset,'enable','on');
        set(btn_Fin,'enable','off');
        set(btn_Debut,'enable','off');
    end

    function Point_Choice(source,callbackdata)
        %set(btn_Debut,'enable','on')
        Indice_Pt_Sel = find(X_time>source.Value,1,'first');
        Int_point_X = X(1,Indice_Pt_Sel);
        Int_point_Y = X(2,Indice_Pt_Sel);
        Int_point_Z = X(3,Indice_Pt_Sel);
        Update_Points_On_Graph(Indice_Pt_Sel)
    end

    function Reset_Traj(source,callbackdata)
        set(btn_Save,'enable','off');
        set(btn_Fin,'enable','off');
        set(btn_Debut,'enable','on');
        set(btn_Reset,'enable','off');
    end

    function Save_Traj(source,callbackdata)
        
        d = dialog('Position',[300 300 250 150],'Name','Select One');
        txt = uicontrol('Parent',d,...
            'Style','text',...
            'Position',[20 80 210 40],...
            'String','Select a color');
        
        Edit = uicontrol('Parent',d,...
            'Style','Edit',...
            'Position',[75 50 100 25],...
            'String','Name',...
            'Callback',@Edit_callback);
        
        popup = uicontrol('Parent',d,...
            'Style','popup',...
            'Position',[75 70 100 25],...
            'String',{'Green';'Blue';'Yellow';'Magenta';'Cyan';'Black'},...
            'Callback',@Color_Choice);
        
        btn = uicontrol('Parent',d,...
            'Position',[29 20 70 25],...
            'String','Close',...
            'Callback','delete(gcf)');
        
        btn_SAVE = uicontrol('Parent',d,...
            'Position',[89 20 70 25],...
            'String','Save',...
            'Callback',@Save_callback);
        
        
        choice = 'Red';
        
        % Wait for d to close before running to completion
        uiwait(d);
        
        function Color_Choice(popup,callbackdata)
            idx = popup.Value;
            popup_items = popup.String;
            % This code uses dot notation to get properties.
            % Dot notation runs in R2014b and later.
            % For R2014a and earlier:
            % idx = get(popup,'Value');
            % popup_items = get(popup,'String');
            choice = char(popup_items(idx,:));
        end
        
        function Edit_callback(Edit,callbackdata)
            Name_Traj = Edit.String;
            % This code uses dot notation to get properties.
            % Dot notation runs in R2014b and later.
            % For R2014a and earlier:
            % idx = get(popup,'Value');
            % popup_items = get(popup,'String');
        end
        
        function Save_callback(btn_SAVE,callbackdata)

            Indice_Traj = Ref_Debut_Traj:Ref_Fin_Traj;
            X_TRAJ = X(:,Indice_Traj);
            VELOCITY_TRAJ = VELOCITY(:,Indice_Traj);
            X_QUAT_TRAJ = X_QUAT(Indice_Traj,:);
            X_time_TRAJ = X_time(Indice_Traj);

            if get(popup,'value')==1
                plot3(X(1,Indice_Traj),X(2,Indice_Traj),X(3,Indice_Traj),'*g','parent',ax_TRAJ)
            end           
            if get(popup,'value')==2
                plot3(X(1,Indice_Traj),X(2,Indice_Traj),X(3,Indice_Traj),'*b','parent',ax_TRAJ)
            end
            if get(popup,'value')==3
                plot3(X(1,Indice_Traj),X(2,Indice_Traj),X(3,Indice_Traj),'*y','parent',ax_TRAJ)
            end

            if get(popup,'value')==4
                plot3(X(1,Indice_Traj),X(2,Indice_Traj),X(3,Indice_Traj),'*m','parent',ax_TRAJ)
            end
            if get(popup,'value')==5
                plot3(X(1,Indice_Traj),X(2,Indice_Traj),X(3,Indice_Traj),'*c','parent',ax_TRAJ)
            end
            if get(popup,'value')==6
                plot3(X(1,Indice_Traj),X(2,Indice_Traj),X(3,Indice_Traj),'*k','parent',ax_TRAJ)
            end
            % int_point(length(int_point)+1).Name = Edit.String;
            % int_point(length(int_point)+1).Color = popup.String;
            % [Point_int_X Point_int_Y Point_int_Z]
            % int_point(length(int_point)+1).Coord = [Int_point_X Int_point_Y Int_point_Z];
            % % This code uses dot notation to get properties.
            % % Dot notation runs in R2014b and later.
            % % For R2014a and earlier:
            % % idx = get(popup,'Value');
            % % popup_items = get(popup,'String');
            %save ([path2,'/PARTIAL_TRAJECTOIRE_1'],'X_TRAJ','VELOCITY_TRAJ','X_QUAT_TRAJ','X_time_TRAJ'); 
            save ([path2,'/PARTIAL_TRAJECTOIRE_',Name_Traj],'X_TRAJ','VELOCITY_TRAJ','X_QUAT_TRAJ','X_time_TRAJ','Indice_Traj'); 
            delete(gcf)
            Reset_Traj;
        end
    end

    function Update_Points_On_Graph(Indice_Pt_Sel)
        set(Point_int_TRAJ,'xdata',X(1,Indice_Pt_Sel),'ydata',X(2,Indice_Pt_Sel),'zdata',X(3,Indice_Pt_Sel),'visible','on')
        set(Point_int_U,'xdata',X_time(Indice_Pt_Sel),'ydata',VELOCITY(1,Indice_Pt_Sel),'visible','on');
        set(Point_int_X,'xdata',X_time(Indice_Pt_Sel),'ydata',X(1,Indice_Pt_Sel),'visible','on');
        set(Point_int_Y,'xdata',X_time(Indice_Pt_Sel),'ydata',X(2,Indice_Pt_Sel),'visible','on');
        set(Point_int_Z,'xdata',X_time(Indice_Pt_Sel),'ydata',X(3,Indice_Pt_Sel),'visible','on');

    end

end