%function FABRICATION_DU_CHEMIN
clear all
close all

%% Coordonn?es spatiales du chemin
% for i = 1 : 600,
%     x_s = 10*sin(3*i/100);
%     y_s = 10*(1-cos(6*i/150));
%     z_s = 10*sin(0.5*i/200);
%     X_S(:,i) = [x_s y_s z_s]';
% end

%load('KARST_PATH.mat');%creates XYZPath
[file,path1] = uigetfile('ENV_3D_POINT_CLOUD*.mat');
load ([path1,file])


%X_S = XYZPath;
X_S = ROB_POS;


%% Coordonn?e curvilin?aire du chemin
DIST_S(1)=0;
D_S(1)=0;
for i = 1 : length(X_S)-1,
    D_S(i+1) = norm(X_S(:,i+1)-X_S(:,i));
    DIST_S(i+1) = DIST_S(i) + D_S(i+1);
end

%% Quaternion d'orientation du li?vre
for i = 1 : length(X_S)-1,
    VECT_TANG_S(:,i)=  X_S(:,i+1)-X_S(:,i);
    if (norm(VECT_TANG_S(:,i))>0.01)
        VECT_TANG_S(:,i)=VECT_TANG_S(:,i)/norm(VECT_TANG_S(:,i));
    else
        VECT_TANG_S(:,i)=[0 0 0];
    end
end
VECT_TANG_S(:,length(X_S))=VECT_TANG_S(:,length(X_S)-1);
for i = 1 : length(VECT_TANG_S)
    if (norm(VECT_TANG_S(:,i))>0.01)
        n = cross([1 0 0]',VECT_TANG_S(:,i));
        n=n/norm(n);
        angle_quat(i) = acos(dot([1 0 0]',VECT_TANG_S(:,i)));
        Q_S(i,:) = [cos(angle_quat(i)/2),sin(angle_quat(i)/2)*n'];
    else
        Q_S(i,:)=[1 0 0 0];
    end
    %     NN = quatmultiply(Q_S(i,:),quatmultiply([0 1 0 0],quatconj(Q_S(i,:))));
    %     VECT2 (:,i) = NN(2:4)';
end

%% Courbure quaternionique du chemin
C_Qc(1,:)=[0 0 0 0];
delta_Q_S(1,:)=[0 0 0 0];
for i = 1 : length(Q_S)-1
    delta_Q_S(i+1,:) = (Q_S(i+1,:)-Q_S(i,:));
    if (abs(D_S(i+1))>0.01)
        C_Qc(i+1,:) = delta_Q_S(i+1,:)/D_S(i+1);
    else
        C_Qc(i+1,:)=[0 0 0 0];
    end
end

%% Derivee spatiale de la courbure quaternionique du chemin
G_Qc(1,:)=[0 0 0 0];
D_delta_Q_S(1,:)=[0 0 0 0];
for i = 1 : length(Q_S)-1
    D_delta_Q_S(i+1,:) = delta_Q_S(i+1,:)-delta_Q_S(i,:);
    if (abs(D_S(i+1))>eps)
        G_Qc(i+1,:) = D_delta_Q_S(i+1,:)/(D_S(i+1)^2);
    else
        G_Qc(1,:)=[0 0 0 0];
    end
end

%%Reechantillonnage
X_S_Reech(:,1)=X_S(:,1);
DIST_Reech(1) = DIST_S(1);
Q_S_Reech(1,:) = Q_S(1,:);
C_Qc_Reech(1,:) = C_Qc(1,:);
G_Qc_Reech(1,:) = G_Qc(1,:);
count=1;

for i = 2 : length(X_S)
    if DIST_S(i)-DIST_S(i-1)>0.1;
        count=count+1;
        X_S_Reech(:,count)=X_S(:,i);
        DIST_Reech(count) = DIST_S(i);
        Q_S_Reech(count,:) = Q_S(i,:);
        C_Qc_Reech(count,:) = C_Qc(i,:);
        G_Qc_Reech(count,:) = G_Qc(i,:);
        VEL_NavScoot(:,count)=VEL_ROB(:,i);
    else
        %do nothing
    end
end


%% Save des param?tres du chemin
Chemin.X = X_S_Reech;
Chemin.S = DIST_Reech;
Chemin.Q_s = Q_S_Reech;
Chemin.C_Qc = C_Qc_Reech;
Chemin.G_Qc = G_Qc_Reech;
Chemin.VEL = VEL_NavScoot;

save ([path1,'Chemin_KARST_',file], 'Chemin')


% figure()
% VECT_TANG_GRAPH = quiver3(0,0,0,0,0,0,'r');
% hold on
% VECT_TANG_GRAPH2 = quiver3(0,0,0,0,0,0,'g');
% plot3(X_S(1,:),X_S(2,:),X_S(3,:),'b')
%
% for i = 1 : length(VECT_TANG_S)
%     set(VECT_TANG_GRAPH,'xdata',X_S(1,i),'ydata',X_S(2,i),'zdata',X_S(3,i),...
%         'udata',10*VECT_TANG_S(1,i),'vdata',10*VECT_TANG_S(2,i),'wdata',10*VECT_TANG_S(3,i));
%     set(VECT_TANG_GRAPH2,'xdata',X_S(1,i),'ydata',X_S(2,i),'zdata',X_S(3,i),...
%         'udata',5*VECT2(1,i),'vdata',5*VECT2(2,i),'wdata',5*VECT2(3,i));
%     drawnow
%     pause(0.1)
% end



