%Cette fonction charge une image d'un circuit, binarise l'image et permet
%par la saisir de 2 points en X et 2 points en Y de dimensionner le circuit
%en metres.
%Elle produit le fichier Circuit_Traite.mat qui sera charge au lancement du
%simulateur

function Topo_Horizontal_Calibration

clear all
close all

global xG yG xD yD xB yB xH yH vecteur_Nord Rotation_Nord Im_Topo

[file,path1] = uigetfile({'*.png';'*.jpg';'*.bmp';'*.tiff'},...
                          'File Selector');
% Create a figure and axes
fig1 = figure();

ax_fig1_1 = axes('Units','pixels','visible','off');

hold on
Im_Topo = imread([path1,file]);%Chargement image circuit
File_Name = file(1:end-4);

image(Im_Topo,'parent',ax_fig1_1)


set(ax_fig1_1,'ydir','normal')
axis equal

XScale = get(ax_fig1_1,'xlim');
YScale = get(ax_fig1_1,'ylim');

% Create push button
btnL = uicontrol('Style', 'pushbutton', 'String', 'Sasie de l echelle',...
    'Position', [5 5 150 20],...
    'Callback', @MiseAlEchelle);

btnNord = uicontrol('Style', 'pushbutton', 'String', 'Saisie Topo',...
    'Position', [245 5 150 20],...
    'Callback', @Saisie_Topo,'enable','off');


txt_TO_DO = uicontrol('Style','text',...
    'Position',[200 390 200 20],...
    'String','TO DO',...
    'fontsize',14);

Scale_Edit = uicontrol('Style','edit',...
    'Position',[160 5 80 20],...
    'String',num2str(XScale(2)-XScale(1)),...
    'enable','off',...
    'Callback',@Saisie_SCALE);


    function MiseAlEchelle(source,callbackdata)
        set(btnL,'enable','off')
        set(txt_TO_DO,'string','SAISIR LIMITE GAUCHE')
        [xG,yG] = ginput(1);
        set(txt_TO_DO,'string','SAISIR LIMITE DROITE')
        [xD,yD] = ginput(1);
        set(txt_TO_DO,'string','SAISIR LARGEUR REELLE (m)')
        set(Scale_Edit,'visible','on','enable','on')
    end
    function Saisie_Topo(source,callbackdata)

        set(btnL,'enable','off')
        set(Scale_Edit,'enable','off')
        xy = [];
        n = 0;
        but = 1;
        while but == 1
            [xi,yi,but] = ginput(1);
            plot(xi,yi,'ro')
            n = n+1;
            xy(:,n) = [xi;yi];
            if n>1
                line([xy(1,n-1),xy(1,n)],[xy(2,n-1),xy(2,n)],'linewidth',2)
            end
        end
        Topo = xy-xy(:,1);
        save ([path1,'Topo_Ref file_',File_Name],'Topo');
    end

    function Saisie_SCALE(source,callbackdata)

        Scale  = str2num(get(Scale_Edit,'string'));
        set(btnL,'enable','off')
        set(Scale_Edit,'enable','off')
        set(btnNord,'enable','on')
        
    end

    function Saisie_Hauteur(source,callbackdata)

        Hauteur  = str2num(get(Hauteur_Edit,'string'));
        set(Hauteur_Edit,'enable','off')

    end

 
end


%pour afficher le terrain :
% load Circuit_Traite.mat
% figure()
% image(Circuit_Sized.CData,'xdata',get(Circuit_Sized,'xdata'),...
%     'ydata',get(Circuit_Sized,'ydata'));
% set(gca,'ydir','normal')