clc
clear all
close all

%Chargement des donn?es relatives aux moteurs : position, orientation, Max_pos, Max_neg, DZ_pos, DZ_neg, Color
%pour Moteur. et Moteur_EST.
%load PARAM_Moteurs_CUBE_REEL
load PARAM_Moteurs_CUBE_THO

%Chargement des param?tres du mod?le dynamique :     m_u, m_v, m_w, m_p, m_q, m_r, d_u, d_v, d_w, d_p, d_q, d_r
%pour Dyn_Robot. et Dyn_Robot_EST.
load PARAM_Dyn_CUBE_REEL

%Chargement des donn?es du chemin : X, S, Q_s, C_Qc, G_Qc
%pour Chemin.

[file,path1] = uigetfile('Chemin_KARST*.mat');
load ([path1,file])

file_ENV_3D = erase(file,'Chemin_KARST_');
load ([path1,file_ENV_3D])

%Chargement du modele du karst
%Lecture du Modele du Karst
% [vertices, faces]= obj__read( 'karstModel.obj' );
% Vert_Karst = [-vertices(3,:);vertices(1,:);vertices(2,:)];
% vert1 = Vert_Karst(:,faces(1,:));
% vert1=vert1';
% vert2 = Vert_Karst(:,faces(2,:));
% vert2=vert2';
% vert3 = Vert_Karst(:,faces(3,:));
% vert3=vert3';
% JS=size(vert1,1);
% jd=1;

Vert_Karst = IMPACT_S;
faces = TRI_BOUND;
vert1 = Vert_Karst(:,faces(1,:));
vert1=vert1';
vert2 = Vert_Karst(:,faces(2,:));
vert2=vert2';
vert3 = Vert_Karst(:,faces(3,:));
vert3=vert3';
JS=size(vert1,1);
jd=1;

%Parametres Capteurs
% Param Sonar profilo
PRM_SNR_PROF.Vit_Rot_Sonar = 3*1.04;%Rad/s -> 6secondes pour un tour complet =2*pi/6
PRM_SNR_PROF.Nbr_Pt_SNR_TOUR = 36;%Nombre de points Sonar PROFILO par tour complet
PRM_SNR_PROF.Portee_SNR = 60;%Portee max du Sonar PROFILO
PRM_SNR_PROF.Pos_B = [0,0,0]';%Position Capteur dans B


%Initialisations de l'?tat du robot
X = [0 0 0]';% x y z % POSITION ITINITALE
Eta = 0*[rand rand rand]';%phi theta psi % ATTITUDE ITINITALE
V_B = [sqrt(2)/2 sqrt(2)/2 0]';% u v w % VITESSES LINEAIRES ITINITALES
W_B = 0*[0 0 3]';% p q r% VITESSES ROTATIONELLES ITINITALES
Q_B_0 = angle2quat(Eta(3),Eta(2),Eta(1));%QUATERNION INITIAL
dot_Q_B_0 = 0.5*quatmultiply(Q_B_0,[0 W_B']);% VITESSE INITIALE QUATERNION
Q_Temp = quatmultiply(quatmultiply(Q_B_0,[0 V_B']),quatconj(Q_B_0));
V_0 =  Q_Temp(2:4)';
ETAT = [X;Q_B_0';V_0;dot_Q_B_0'];%ETAT INITIAL

%Initialisation de l'etat du li?vre
S = 0;
dot_s = 0;
%Periode de controle
dt =0.1;

%Calcul Concentrateur
Concentrateur = Calcul_Concentrateur(Moteur);%Modele d'actionnement
NOYAU = null(Concentrateur);
F_M_0_1 = NOYAU(:,1);
F_M_0_2 = NOYAU(:,2);

%Initialisation des integrateurs
%INT_ERREUR_V_B = [0 0 0]'; INT_DPHI=0; INT_DTHETA=0; INT_DPSI=0;Qe_INT=[0 0 0 0];INT_Q = [0 0 0 0];

tic
INIT_GRAPHIQUES
hold on
count = 0;

vertices_map = [];Faces_map= [];
Nbr_Tour_Sonar = 0;count_sonar_point_per_turn=0;invalid_point=0;

norm_V_0_des = 0.5;
time=0;
for ii = 1:1200
    toc; tic
    
    
    %date du prochain lancer de rayon pour SNR Profilo
    dt_SNR_PROF = (2*pi/PRM_SNR_PROF.Nbr_Pt_SNR_TOUR)/PRM_SNR_PROF.Vit_Rot_Sonar;
    dt=dt_SNR_PROF;
    time = time + dt;
    
    % Appel SONAR PROFILO
    Alpha_SNR_Prof = PRM_SNR_PROF.Vit_Rot_Sonar * time;
    [Distance,Alpha,point_inters]=SONAR_PROFILO(vert1,vert2,vert3,JS,jd,ETAT(1:3)',Alpha_SNR_Prof,ETAT(4:7)',PRM_SNR_PROF);
    
    %calcul des coordonn?es absolues des impacts
    
    %%%
    
    
    
    % construction de la carte en ligne
    Map.Distance(ii) = Distance;
    Map.Alpha(ii) = Alpha;
    Map.point_inters.x(ii) = point_inters(1);
    Map.point_inters.y(ii) = point_inters(2);
    Map.point_inters.z(ii) = point_inters(3);
    Map.Rob.x(ii) = ETAT(1);
    Map.Rob.y(ii) = ETAT(2);
    Map.Rob.z(ii) = ETAT(3);
    
    if isnan(point_inters(1)),
        invalid_point = invalid_point +1;
    else
        vertices_map = [vertices_map;point_inters(1) point_inters(2) point_inters(3)];
        
        count_sonar_point_per_turn = count_sonar_point_per_turn + 1;
        %     if count_sonar_point_per_turn>PRM_SNR_PROF.Nbr_Pt_SNR_TOUR% = 36
        %         Nbr_Tour_Sonar = Nbr_Tour_Sonar +1;
        %         Nbr_Tour_Sonar=1;
        %         count_sonar_point_per_turn = 0;
        %     end
        
        if count_sonar_point_per_turn>PRM_SNR_PROF.Nbr_Pt_SNR_TOUR,
            Faces_map = [Faces_map;(ii-invalid_point)-(PRM_SNR_PROF.Nbr_Pt_SNR_TOUR-1) (ii-invalid_point)-(PRM_SNR_PROF.Nbr_Pt_SNR_TOUR-2) (ii-invalid_point)];
            Faces_map = [Faces_map;(ii-invalid_point)-(PRM_SNR_PROF.Nbr_Pt_SNR_TOUR-2) (ii-invalid_point) (ii-invalid_point+1)];
        end
    end
    %%%%%%%%%%%%%%%%%%%
    
    %% Etat = [X;Q';V0;dot_Q'];
    X = ETAT(1:3);
    Q_B_0 = ETAT(4:7)';
    V_0 = ETAT(8:10);
    dot_Q_B_0 = ETAT(11:14)';
    
    %% CALCUL DES VITESSES DANS LE BODY FRAME
    Q_Temp=2*quatmultiply(quatinv(Q_B_0),dot_Q_B_0);
    W_B = Q_Temp(2:4);
    Q_Temp = quatmultiply(quatmultiply(quatconj(Q_B_0),[0 V_0']),Q_B_0);
    V_B = Q_Temp(2:4);
    
    %% CALCUL DU QUATERNION D'ORIENTATION DE LA VITESSE ABSOLUE
    Q_V_T_0 = Quat_Orientation_Vect(V_0);
    
    %% CALCUL DES REFERENCES SUR LE CHEMIN : Recherche des param?tres du li?vre
    Lievre = Interrogation_chemin(Chemin,S);
    dot_Q_s =  Lievre.C_Qc*dot_s;
    Q_Temp = quatmultiply(quatmultiply(Lievre.Q_s,[0 dot_s 0 0]),quatconj(Lievre.Q_s));
    Vit_S_0 =  Q_Temp(2:4)';
    
    %% CALCUL DU QUATERNION D'INCIDENCE
    % Expression de la position du robot dans le repere de frenet (li?vre)
    [s_1,y_1,z_1, dot_s1,dot_y1,dot_z1,Q_theta] = Quaternion_incidence(Lievre,X,Vit_S_0,V_0,Q_V_T_0);
    
    
    %% CALCUL DU QUATERNION D'APPROCHE
    [Q_delta,dot_Q_delta] = Quaternion_Approche (y_1,z_1,dot_y1,dot_z1,Lievre,dot_Q_s);
    
    %% CALCUL DES REFERENCES D'ORIENTATION
    
    %on cherche ? viser le point : X_Orient_D = [0 8 0]'; defini ?
    %l'initialisation graphique
    
    %on X_Orient_Dcalcule le vecteur X -> X_Orient_D
    X_Orient_D
    V = X_Orient_D - X;
    dot_V = -V_0;
    %On calcule le quaternon associ? ? cette direction
    [Q_D,dot_Q_D] = quaternion_vecteur_et_derivee(V,dot_V);
    
    %Pour orienter le systeme sur la tangente au chemin
    Q_D=Lievre.Q_s;
    dot_Q_D=Lievre.C_Qc*dot_s;
    
    %     dot_W_D = [0 0 0]';
    %     Q_Temp = 2*quatmultiply(quatconj(Q_D),dot_Q_D);
    %     W_D = Q_Temp(2:4)';
    ddot_Q_D = [0 0 0 0];%.5*( quatmultiply(dot_Q_D,[0 W_D']) + quatmultiply(Q_D,[0 dot_W_D']));
    
    
    %% CALCUL DES ACCELERATIONS ROTATIONELLES DE CONTROLE
    [dot_W_B_CONTROL,VAR_TEMP1,dot_Q_e,Q_e]=Control_Acc_Rot(Q_B_0,W_B,Q_D,dot_Q_D,ddot_Q_D);
    %% CALCUL DES ACCELERATIONS LINEAIRES DE CONTROLE
    [dot_V_B_CONTROL]=Control_Acc_Lin(Q_B_0,Q_delta,Lievre,dot_Q_s,dot_Q_delta,V_0,norm_V_0_des);
    %% CALCUL DES FORCES DESIREES BODY_FRAME
    [F_B_DES]=Robot_Dyn_Model(W_B,dot_W_B_CONTROL,V_B,dot_V_B_CONTROL,Dyn_Robot);
    %% CALCUL DES FORCES MOTEURS
    F_M_CONTROL = pinv(Concentrateur)*F_B_DES
    %% CALCUL DES ENTREES MOTEURS
    PWM =Carract_INV_Moteurs(Moteur,F_M_CONTROL);%Moteur_EST
    %PWM=0*PWM;
    
    
    if norm(Vit_S_0)>0.00000001,
        dot_s = norm(V_0)*dot(V_0/norm(V_0),Vit_S_0/norm(Vit_S_0)) + 10*s_1;
    else
        dot_s =norm(V_0)+ 10*s_1;
    end
    dot_s=1;
    S=S+dot_s*dt;
    

    
    
    %% MISE A JOUR GRAPHIQUE
    plot3(point_inters(1),point_inters(2),point_inters(3),'*k')
    count = count + 1;
    if count>=1,
        MISE_A_JOUR_GRAPHIQUE
        count = 0;
    end
    
    
    %% INTEGRATION (SIMULATION)
    [t45,x45]=ode45(@(t,ETAT)modele_GEN(ETAT,Concentrateur,Dyn_Robot,Moteur,PWM),[0,dt],ETAT);
    L45=length(t45);
    ETAT=x45(L45,:)';
    X = ETAT(1:3);
    Q_B_0 = ETAT(4:7)';
    V_0 = ETAT(8:10);
    dot_Q_B_0 = ETAT(11:14)';
    
    
    
    
    %% STOCKAGE DES DONNEES POUR AFFICHAGE
    %    W_D_STOCK(:,ii) = W_D;
    VAR_TEMP1_STOCK(:,ii) = VAR_TEMP1;
    dot_Q_e_STOCK(:,ii) = dot_Q_e;
    Q_e_STOCK(:,ii) = Q_e;
    Q_D_STOCK(:,ii) = Q_D;
    Q_B_0_STOCK(:,ii) = Q_B_0;
    X_Stock(ii)=X(1);
    Y_Stock(ii)=X(2);
    Z_Stock(ii)=X(3);
    W_B_STOCK(:,ii) = W_B;
    TIME(ii) = time;
    PWM_STOCK(:,ii) = PWM;
    V_B_STOCK(:,ii) = V_B;
    [PSI_STOCK(ii),ROLL_STOCK(ii),PHI_STOCK(ii)] = quat2angle(Q_B_0);
    P_SB_F_STOCK(:,ii)=[s_1;y_1;z_1];
    
end

Faces_mapt = Faces_map(1:end-1,:);
save Map_DATA vertices_map Faces_mapt Map

figure()
trisurf(Faces_mapt, vertices_map(:,1), vertices_map(:,2), vertices_map(:,3),'FaceAlpha', 0.4,'linestyle','none')

% figure()
% plot(TIME,PWM_STOCK);title('PWM')
%
% figure()
% plot(TIME,W_B_STOCK);title('W_B (rad/s) et W_D (r)')
% hold on
% %plot(TIME,W_D_STOCK,'--')
%
% figure()
% plot(TIME,V_B_STOCK);title('V_B')
% figure()
% plot(TIME,PHI_STOCK,'r');title('\phi (r), \theta (g), \psi (b)')
% hold on
% plot(TIME,ROLL_STOCK,'g')
% plot(TIME,PSI_STOCK,'b')
% figure()
% plot3(X_Stock,Y_Stock,Z_Stock);title('trajectoire');grid
% figure()
% plot(TIME,X_Stock,'r');title('X (r), Y (g), Z (b)')
% hold on
% plot(TIME,Y_Stock,'g')
% plot(TIME,Z_Stock,'b')
%
% figure()
% hold on
% plot(TIME,VAR_TEMP1_STOCK(1,:),'r');title('Terme comparaison HIL VAR_TEMP1')
% plot(TIME,VAR_TEMP1_STOCK(2,:),'g')
% plot(TIME,VAR_TEMP1_STOCK(3,:),'b')
% plot(TIME,VAR_TEMP1_STOCK(4,:),'k')
%
% figure()
% hold on
% plot(TIME,dot_Q_e_STOCK(1,:),'r');title('Terme comparaison HIL dot_Q_e_STOCK')
% plot(TIME,dot_Q_e_STOCK(2,:),'g')
% plot(TIME,dot_Q_e_STOCK(3,:),'b')
% plot(TIME,dot_Q_e_STOCK(4,:),'k')
%
% figure()
% hold on
% plot(TIME,Q_e_STOCK(1,:),'r');title('Q_e')
% plot(TIME,Q_e_STOCK(2,:),'g')
% plot(TIME,Q_e_STOCK(3,:),'b')
% plot(TIME,Q_e_STOCK(4,:),'k')
%
%
% figure()
% hold on
% plot(TIME,Q_B_0_STOCK(1,:),'r');title('Q_B_0 et Q_D')
% plot(TIME,Q_B_0_STOCK(2,:),'g')
% plot(TIME,Q_B_0_STOCK(3,:),'b')
% plot(TIME,Q_B_0_STOCK(4,:),'k')
% plot(TIME,Q_D_STOCK(1,:),'--r')
% plot(TIME,Q_D_STOCK(2,:),'--g')
% plot(TIME,Q_D_STOCK(3,:),'--b')
% plot(TIME,Q_D_STOCK(4,:),'--k')
%
% figure()
% plot(TIME,P_SB_F_STOCK(1,:),'r')
% hold on
% plot(TIME,P_SB_F_STOCK(2,:),'g')
% plot(TIME,P_SB_F_STOCK(3,:),'b')


