function [Q,dot_Q] = quaternion_vecteur_et_derivee(V,dot_V)

    if norm(V)>0.00001,
        V1 = V/norm(V);
        dot_V1 = dot_V/norm(V) - V1*(dot(V,dot_V))/(norm(V)^2);
        n_Orient0 = cross([1 0 0]',V1);
        dot_n_Orient0 = cross([1 0 0]',dot_V1);
        n_Orient = n_Orient0/norm(n_Orient0);
        dot_n_Orient = dot_n_Orient0/norm(n_Orient0) - n_Orient*(dot(n_Orient0,dot_n_Orient0))/(norm(n_Orient0)^2);

        
        alpha_Orient = acos(dot([1 0 0]',V1));
        if abs(alpha_Orient)>0.00001
            dot_alpha_Orient = -(dot([1 0 0]',dot_V1)) / sqrt(1 - (dot([1 0 0]',V1))^2);
        else
            dot_alpha_Orient=0;
        end
        
    else
        n_Orient = [0 0 0]';
        dot_n_Orient = [0 0 0]';
        alpha_Orient = 0;
    end

    Q = [cos(alpha_Orient/2),sin(alpha_Orient/2)*n_Orient'];
    dot_Q = (dot_alpha_Orient/2)*[-sin(alpha_Orient/2),cos(alpha_Orient/2)*n_Orient']+...
        [0 sin(alpha_Orient/2)*dot_n_Orient'];