%function [ETAT_NEW,F_B,F_M,etatt]=Modele_Dynamique_ET_Integration_COMPLETE_ODE(ETAT,Concentrateur,PWM,Dyn_Robot,Moteur,dt,etatt)
function ETAT_DOT = modele_GEN(ETAT,Concentrateur,Dyn_Robot,Moteur,PWM)

%Etat = [X;Q';V0;dot_Q'];
X = ETAT(1:3);
Q_B_0 = ETAT(4:7)';
V_0 = ETAT(8:10);
dot_Q_B_0 = ETAT(11:14)';

Q_Temp = quatmultiply(quatmultiply(quatconj(Q_B_0),[0 V_0']),Q_B_0);
V_B = Q_Temp(2:4)';
[Q_Temp]=2*quatmultiply(quatinv(Q_B_0),dot_Q_B_0);
W_B = Q_Temp(2:4)';

F_M =  Carract_Moteurs(Moteur,PWM);
F_B = Concentrateur*F_M;

dot_u = (1/Dyn_Robot.m_u)*(F_B(1) - Dyn_Robot.d_u*V_B(1));
dot_v = (1/Dyn_Robot.m_v)*(F_B(2) - Dyn_Robot.d_v*V_B(2));
dot_w = (1/Dyn_Robot.m_w)*(F_B(3) - Dyn_Robot.d_w*V_B(3));
dot_p = (1/Dyn_Robot.m_p)*(F_B(4) - Dyn_Robot.d_p*W_B(1));
dot_q = (1/Dyn_Robot.m_q)*(F_B(5) - Dyn_Robot.d_q*W_B(2));
dot_r = (1/Dyn_Robot.m_r)*(F_B(6) - Dyn_Robot.d_r*W_B(3));

dot_V_B = [dot_u dot_v dot_w]';
dot_W_B = [dot_p dot_q dot_r]';

Q_Temp = quatmultiply(quatmultiply(Q_B_0,[0 dot_V_B']),quatconj(Q_B_0));
dot_V_0 = Q_Temp(2:4)';
ddot_Q_B_0 = 0.5*quatmultiply(dot_Q_B_0,[0 W_B']) + 0.5*quatmultiply(Q_B_0,[0,dot_W_B']);

%Prise en compte de la contrainte de normalisation du quaternion

A = ETAT(4:7)';
M_V = eye(3);
M_Q = eye(4);
M_Contraint = [M_V zeros(3,4) zeros(3,1) ; zeros(4,3) M_Q -A' ; zeros(1,3) A 0];
A_dot = ETAT(11:14)';
B = -A_dot*A_dot';
ETAT_DOT_L = inv(M_Contraint)*[dot_V_0 ; ddot_Q_B_0' ; B];
ETAT_DOT = [ETAT(8:14);ETAT_DOT_L(1:end-1)];

%[t45,x45]=ode45(@(t,x) modele3(x,A,b),[0 dt],x);

%% Integration du mouvement lineaire
% X=X+V_0*dt;
% V_0=V_0+dot_V_0*dt;
% 
% 
% 
% %%% 
% %etattdot = Modele_pour_integration(etatt,ddot_Q_B_0)
% 
% [t45,x45]=ode45(@(t,etatt)Modele_pour_integration(etatt,ddot_Q_B_0),[0,dt],etatt);
% L45=length(t45);
% etatt=x45(L45,:)';
% Q_B_0_NEW = etatt(1:4)';
% dot_Q_B_NEW = etatt(5:end)';
% %[norm(Q_B_0_NEW);dot(Q_B_0_NEW,dot_Q_B_NEW)]
% 
% %% Integration du mouvement rotationnel
% % dot_Q_B_0=dot_Q_B_0+ddot_Q_B_0*dt;
% % Q_B_0 = quatnormalize(Q_B_0+dot_Q_B_0*dt);
% %[Q_B_0_NEW',Q_B_0']
% %Q_B_0_2 = quatmultiply(Q_B_0,quatnormalize(dot_Q_B_0*dt));
% %[Q_B_0' Q_B_0_2']
% Q_B_0 = Q_B_0_NEW;
% dot_Q_B_0 = dot_Q_B_NEW;
% [Eta(3),Eta(2),Eta(1)] = quat2angle(Q_B_0);
% ETAT_NEW = [Q_B_0,dot_Q_B_0,X,V_0];
