clear all
close all

[path1] = uigetdir;

load ([path1,'/DATA_MISSION_VALID']);



%% Detection des zones inexploitables en debut de Skyline
figure()
hold on
text(100,50,'Detection des zones inexploitables en debut de Skyline')
text(100,45,'Clic dans le graphe pour definir le seuil')
text(100,40,'Clic en dehors (a gauche) du graphe pour terminer')

offset=1;
for i = 1 : length(SONAR_TRITECH_VALID.GLOB_TIME)
    
    plot(SONAR_TRITECH_VALID.SKYLINE(i,1:SONAR_TRITECH_VALID.NBR_BINS(i)))
    drawnow
    text(100,50,'Detection des zones inexploitables en debut de Skyline')
    text(100,45,'Clic dans le graphe pour definir le seuil')
    text(100,40,'Clic en dehors (a gauche) du graphe pour terminer')
    [offset,~]=ginput(1)
    if offset>0
        offset_x(i)=offset;
    else
        break;
    end
    clf
end

offset_bins = 1+floor(max(offset_x))

%% Application de l'offset_bins:
for i = 1 : length(SONAR_TRITECH_VALID.GLOB_TIME)
    SONAR_TRITECH_VALID.SKYLINE(i,1:offset_bins)=0;
end

%% Extraction des impacts valides du Sonar

threshold = 2;
Count_Impact = 1;
for i = 1 : length(SONAR_TRITECH_VALID.GLOB_TIME)
    Longueur_Skyline = SONAR_TRITECH_VALID.NBR_BINS(i);
    def_bin = SONAR_TRITECH_VALID.RANGE(i)/SONAR_TRITECH_VALID.NBR_BINS(i);
    Impact_Indices = find(SONAR_TRITECH_VALID.SKYLINE(i,1:Longueur_Skyline)>threshold,1,'first');
    if length(Impact_Indices)>0
        DISTANCE = def_bin*Impact_Indices;
        if DISTANCE<SONAR_TRITECH_VALID.RANGE(i)%% HORS PORTEE
            IMPACT.DIST(Count_Impact)=DISTANCE;
            IMPACT.ANGLE(Count_Impact) = SONAR_TRITECH_VALID.ANGLE(i);
            IMPACT.GLOB_TIME(Count_Impact) = SONAR_TRITECH_VALID.GLOB_TIME(i);
            Count_Impact = Count_Impact + 1;
        end
    end
end

%% Rejet des impacts uniques distants de plus du demi-range
% count_rejets=1;
% for i = 2 : length(IMPACT.DIST)-1
%     Dist_Avant = IMPACT.DIST(i)-IMPACT.DIST(i-1);
%     Dist_Apres = IMPACT.DIST(i)-IMPACT.DIST(i+1);
%     if (Dist_Avant>SONAR_TRITECH_VALID.RANGE(i)/2)&&(Dist_Apres>SONAR_TRITECH_VALID.RANGE(i)/2)
%         IMPACT_REJETE.DIST(count_rejets)= IMPACT.DIST(i);
%         IMPACT_REJETE.ANGLE(count_rejets)= IMPACT.ANGLE(i);
%         IMPACT_REJETE.GLOB_TIME(count_rejets)= IMPACT.GLOB_TIME(i);
%         IMPACT.DIST(i) = (IMPACT.DIST(i-1)+IMPACT.DIST(i+1))/2;
%         count_rejets=count_rejets+1;
%     end
% end
% count_rejets

count=1;
SCAN(count).Indices = [1];
%% Decoupage des SCANS
for i = 2 : length(IMPACT.ANGLE)
    SCAN(count).Indices = [SCAN(count).Indices,i];
    if abs(IMPACT.ANGLE(i)-IMPACT.ANGLE(i-1))>90,%NEW SCAN
        count=count+1;
        SCAN(count).Indices = [];
    end
end
count_TRI_FORWARD = 1;
%% Recherche (FORWARD) du mapping entre scans
for i = 2 : length(SCAN)-1
    for j=1 : length(SCAN(i).Indices)-1
        % Recherche du point le plus proche dans le scan suivant
        for k = 1 : length(SCAN(i+1).Indices)
            Difference_AVANT(k) = IMPACT.ANGLE(SCAN(i).Indices(j)) - IMPACT.ANGLE(SCAN(i+1).Indices(k));
            if Difference_AVANT(k)>180,
                Difference_AVANT(k) = Difference_AVANT(k) - 360;
            end
            if Difference_AVANT(k)<-180,
                Difference_AVANT(k) = Difference_AVANT(k) + 360;
            end
        end
        for k = 1 : length(SCAN(i-1).Indices)
            Difference_ARRIERE(k) = IMPACT.ANGLE(SCAN(i).Indices(j)) - IMPACT.ANGLE(SCAN(i-1).Indices(k));
            if Difference_ARRIERE(k)>180,
                Difference_ARRIERE(k) = Difference_ARRIERE(k) - 360;
            end
            if Difference_ARRIERE(k)<-180,
                Difference_ARRIERE(k) = Difference_ARRIERE(k) + 360;
            end
        end
        [Val,Ind]=min(abs(Difference_AVANT));
        TRI(count_TRI_FORWARD,:)=[SCAN(i).Indices(j) SCAN(i).Indices(j+1) SCAN(i+1).Indices(Ind)];
        kk = Ind-1;
        if kk<1
            kk=length(SCAN(i+1).Indices);
        end
        TRI(count_TRI_FORWARD+1,:)=[SCAN(i).Indices(j) SCAN(i+1).Indices(Ind) SCAN(i+1).Indices(kk)];
        
        count_TRI_FORWARD=count_TRI_FORWARD+2;
        
        [Val,Ind]=min(abs(Difference_ARRIERE));
        TRI(count_TRI_FORWARD,:)=[SCAN(i).Indices(j) SCAN(i).Indices(j+1) SCAN(i-1).Indices(Ind)];
        kk = Ind-1;
        if kk<1
            kk=length(SCAN(i-1).Indices);
        end
        TRI(count_TRI_FORWARD+1,:)=[SCAN(i).Indices(j) SCAN(i-1).Indices(Ind) SCAN(i-1).Indices(kk)];
        count_TRI_FORWARD=count_TRI_FORWARD+2;

         Difference_AVANT=[];
         Difference_ARRIERE=[];
    end
end


save ([path1,'/IMPACT_SONAR_TRITECH'],'IMPACT','SCAN','TRI');




